<template>
  <q-page class="flex flex-center justify-center column">
    <div class="top">
      <h1>
        <img
          src="icons/logo_gps.svg"
          alt="logo de gnu personal stats"
          style="max-width:10rem;"
        >
      </h1>
    </div>

    <div class="login" v-if="loggedIn === false">
      <h2>connexion</h2>
      <form class="bottom_forms__child" action="">
        <q-input filled v-model="loginName" label="Name" for="loginNameId" />
        <q-input filled v-model="loginPass" label="Pass" type="password" for="loginPassId" />
        <q-btn
          @click.prevent="connexion(loginName, loginPass)"
          label="se connecter"
          type="submit"
          color="primary"
        />
      </form>
    </div>

    <div class="createAccount" v-if="loggedIn === false">
      <h2>créer un compte</h2>
      <form class="bottom_forms__child" action="">
        <q-input filled v-model="createAccountName" label="nom utilisateur" />
        <q-input filled v-model="createAccountMail" label="e-Mail" type="email" />
        <q-input
          filled
          v-model="createAccountPass"
          label="passphrase"
          type="password"
        />
        <q-input
          filled
          v-model="createAccountPass2"
          label="confirmation passphrase"
          type="password"
        />
        <q-btn
          @click.prevent="createUser"
          label="créer un compte"
          type="submit"
          color="primary"
        />
      </form>
    </div>

    <div class="createAccount" v-if="loggedIn === true">
      <h2>vous êtes connecter</h2>
      <q-btn
        @click.prevent="logout"
        label="déconnexion"
        type="button"
        color="primary"
      />
    </div>
  </q-page>
</template>

<script>
import { computed, defineComponent, ref } from 'vue';
import { useRouter } from 'vue-router';
import { useAuthStore } from 'src/stores/authStore.js';
import { useQuasar } from 'quasar';

export default defineComponent({

  name: 'helloWorld',
  props: {
    msg: String,
  },
  setup() {
    const router = useRouter();
    const users = ref([]);
    const loginName = ref('');
    const loginPass = ref('');
    const createAccountName = ref('');
    const createAccountMail = ref('');
    const createAccountPass = ref('');
    const createAccountPass2 = ref('');
    const authStore = useAuthStore();
    const loggedIn = computed(() => authStore.loggedIn);
    const quasar = useQuasar();

    const connexion = (login, pass) => {
      authStore.login(login, pass)
        .then((bol) => {
          if (bol === true) {
            router.push({ name: 'account' });
          } else {
            quasar.notify({
              message: 'ces identifiants ne permettent pas de vous connecter',
              color: 'negative',
              badgeTextColor: 'white',
              progress: true,
              timeout: 15000,
            });
          }
        });
    };

    const createUser = () => {
      if (createAccountPass.value !== createAccountPass2.value) {
        quasar.notify({
          message: 'les 2 mots de passe ne sont pas identiques!',
          color: 'negative',
          badgeTextColor: 'white',
          progress: true,
        });
        return console.log('les 2 passwords ne sont pas identiques!');
      }
      if (createAccountMail.value === '') {
        quasar.notify({
          message: 'vous devez renseigner un mail',
          color: 'negative',
          badgeTextColor: 'white',
          progress: true,
        });
        return console.log('les 2 passwords ne sont pas identiques!');
      }
      const requestOptionsConn = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({
          userName: createAccountName.value,
          mail: createAccountMail.value,
          pass: createAccountPass.value,
          comment: '',
        }),
      };
      fetch(`${import.meta.env.VITE_FETCH_BACK}/users`, requestOptionsConn)
        .then((response) => {
          response.json();
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'il est possible que ce nom soit déjà pris',
            });
            throw response.status;
          }
          quasar.notify({
            message: 'bienvenu sur votre nouveau compte',
            color: 'positive',
            badgeTextColor: 'white',
            progress: true,
          });
          connexion(createAccountName.value, createAccountPass.value);
        })
        .then((data) => {
          users.value.push(data);
        });
    };

    return {
      loginName,
      loginPass,
      createAccountName,
      createAccountMail,
      createAccountPass,
      createAccountPass2,
      connexion,
      createUser,
      loggedIn,
      logout() {
        router.push('/');
        authStore.logout();
      },
    };
  },
});
</script>
<style scoped>
.q-btn {
  width: 100%;
}
.login,
.createAccount {
  width: 30rem;
  max-width: 100%;
}
.createAccount {
  margin-bottom: 5rem;
}
</style>
